DECLARE SUB DoLinkSys (pass AS STRING)
DECLARE SUB OverworldEditor ()
DECLARE SUB PutMapBack ()
DECLARE SUB BlitNme (x%, y%, pxloff%, Z%)
DECLARE SUB ScrollMapLeft (xoff AS INTEGER, xdest AS INTEGER, ScrollSpeed%)
DECLARE SUB ScrollMapRight (xoff AS INTEGER, xdest AS INTEGER, ScrollSpeed%)
DECLARE SUB DrawMap (xoff AS INTEGER, startx%, endx%, pxloff%)
DECLARE SUB DrawTile (x%, y%, pxloff%, Z%)
DECLARE SUB DrawNme (xoff AS INTEGER, pxloff AS INTEGER)
DECLARE SUB LoadFile ()
DECLARE SUB Initalize ()
DECLARE SUB ChooseMap ()
DECLARE SUB BlitNme (x%, y%, pxloff%, Z%)
DECLARE SUB ChangeNme (change%)
DECLARE SUB ChangeObj (change AS INTEGER)
DECLARE FUNCTION CheckChangedMap% ()
DECLARE SUB DrawDialogBox ()
DECLARE SUB ShadowPrint (Text$, x%, y%)
DECLARE SUB SaveIt ()
DECLARE FUNCTION Checkit% ()
DECLARE SUB nmeConvert ()
DECLARE SUB GetNewMap ()
DECLARE SUB ScrollMapLeft (xoff AS INTEGER, xdest AS INTEGER, ScrollSpeed%)
DECLARE SUB ScrollMapRight (xoff AS INTEGER, xdest AS INTEGER, ScrollSpeed%)
DECLARE SUB DrawMap (xoff AS INTEGER, startx%, endx%, pxloff%)
DECLARE SUB DispKeys (set AS STRING)
DECLARE SUB DispStats (set AS STRING)
DECLARE SUB Prefs ()
DECLARE SUB HexDump (where AS LONG)
DECLARE SUB Editor ()
DECLARE SUB nmeEditor ()
DECLARE SUB setpal (pl AS INTEGER)
DECLARE SUB DrawBox (xoff%, ooff%)
DECLARE SUB DrawTile (x%, y%, pxloff%, Z%)
DECLARE SUB DrawNme (xoff AS INTEGER, pxloff AS INTEGER)
DECLARE SUB EditBack ()
DECLARE SUB ScrollHandler ()
DECLARE SUB TsetEdit ()
DECLARE SUB PalEdit ()
DECLARE SUB FlagsEdit ()
DECLARE SUB MoveItLeft ()
DECLARE SUB MoveItRight ()
DECLARE FUNCTION GetKey$ ()
DECLARE FUNCTION GetX% (objno AS INTEGER)
DECLARE FUNCTION hex2$ (param AS LONG)
DECLARE SUB Paws ()
DECLARE FUNCTION IntegrityCheck% (F AS INTEGER)
DECLARE SUB nmeSort ()
DECLARE SUB PutNmeBack ()
DECLARE SUB nmeDrawBox (xoff%, noff%)
DECLARE SUB nmeRecenter ()
DECLARE SUB nmeSetx (nmeno%, x%)
DECLARE FUNCTION Prompt$ (pmt AS STRING, ext AS STRING, dft AS STRING)
DECLARE FUNCTION YesOrNo% ()
DECLARE SUB RenderMap ()
DECLARE SUB makeback ()
DECLARE SUB Convert ()
DEFINT A-Z                'Make new varables integer by default
'$STATIC

'$INCLUDE: 'directqb.bi'  'Include the code provided by DirectQB library
'$INCLUDE: 'z2pledit.bi'  'Include common stuff

'Link System
DIM SHARED LinkSys AS STRING

CLEAR , , 1999

cmd$ = COMMAND$ 'Used because QB11 can't be used

BackInd = 0
verbose = -1
NoCandle = 0
ScrollMode = 0


'====================
'Now the code begins!
'====================

PRINT : PRINT                 'Make 2 empty lines
twemp = CSRLIN                'Clear
LOCATE twemp, 1               ' out
PRINT SPACE$(160);            '  the
LOCATE twemp, 1               '   junk
PRINT "Zelda 2 Sideview Editor, Version 1.99a"     'Display program and Version
PRINT "Started on 1/15/2000, Compiled 3/10/2000, 9:30PM"  'Time and dates

LoadFile   'Gets a filename

Initalize  'Initalizes everything, and loads the file

ChooseMap  'Start the program!

'Editor     'Start the editor!
'NmeEditor

'=============
'Closing code:
'=============
exitit:

DQBclose        'Give memory back, and close the lib

SCREEN 0
WIDTH 80

PRINT "Zelda 2 Sideview Editor, Version 1.99a"


SYSTEM          'Exit QBASIC

SUB ChangeNme (change)

obb = nme(noff).ob

nme(noff).ob = (nme(noff).ob + 64 + change) MOD 64

END SUB

SUB ChangeObj (change AS INTEGER)

'There's a different handler for objects separated by 256

IF obj(ooff).ob < 256 THEN
  obj(ooff).ob = ((obj(ooff).ob + change) + 256) MOD 256
ELSE
  obj(ooff).ob = (((obj(ooff).ob + change) + 256) MOD 256) + 256
END IF
RenderMap

END SUB

FUNCTION CheckChangedMap
  IF LvMod = -1 THEN
    DrawDialogBox
    ShadowPrint "Warning!", 70, 20
    ShadowPrint "The map has changed!  Save Changes?", 30, 30
    ShadowPrint "Y) Yes", 38, 36
    ShadowPrint "N) No", 38, 42
    ShadowPrint "ESC) Cancel", 30, 48
    DO
      DO
        k$ = UCASE$(INKEY$)
      LOOP WHILE k$ = ""
      SELECT CASE k$
        CASE "T", "Y", "U", CHR$(13)
          IF IntegrityCheck(1) THEN
            PutMapBack
            SaveIt
            LvMod = 0
            CheckChangedMap = 0
          ELSE
            CheckChangedMap = -1
          END IF
          EXIT DO
        CASE "B", "N", "M"
          LvMod = 0
          CheckChangedMap = 0
          EXIT DO
        CASE CHR$(27), "X", "C", "V"
          CheckChangedMap = -1
          EXIT DO
      END SELECT
    LOOP
  END IF
END FUNCTION

FUNCTION Checkit
Checkit = -1

FOR x = 0 TO numobj
  IF obj(x).xs > 15 OR obj(x).xs < 0 THEN
    Checkit = x: EXIT FUNCTION
  END IF
  IF obj(x).ob = 15 AND obj(x).yp < &HD THEN Checkit = 256 + x: EXIT FUNCTION
  IF obj(x).ob > 15 AND obj(x).ob < 32 AND obj(x).yp < &HD AND rombank = 1 THEN
    Checkit = 256 + x: EXIT FUNCTION
  END IF
  IF obj(x).yp > 15 OR obj(x).yp < 0 THEN
    Checkit = 768 + x: EXIT FUNCTION
  END IF
  IF obj(x).ob < 0 OR obj(x).ob > 511 THEN
    Checkit = 1024 + x: EXIT FUNCTION
  END IF
  IF GetX(x) > 63 THEN
    Checkit = 512 + x: EXIT FUNCTION
  END IF
NEXT

END FUNCTION

SUB ChooseMap
DIM getbyte AS STRING * 1
DIM bite1 AS LONG, bite2 AS LONG
DIM oldthemap

TheOldMap = -255
TheMap = 315
DO
  IF TheMap < 0 THEN TheMap = 0
  IF TheMap > 503 THEN TheMap = 503
  IF TheMap <> TheOldMap THEN
   IF CheckChangedMap = 0 THEN
    DaMap = TheMap MOD 63
    DaSet = TheMap \ 63

    IF DaSet >= 5 THEN DaSet = DaSet + 1
   
    rombank = DaSet \ 2 + 1
    IF DaSet MOD 2 = 0 THEN
      PointOff = &H533
      nmePointOff = &H5B1
    END IF
    IF DaSet MOD 2 = 1 THEN
      PointOff = &H2010
      nmePointOff = &H208E
    END IF

    PointOff = PointOff + DaMap * 2 + 16384 * rombank
    nmePointOff = nmePointOff + DaMap * 2 + 16384 * rombank
   
    Setoff = (rombank - 2) * 16384
    Offset = 0
    DQBpeek VARSEG(Offset), VARPTR(Offset), PointOff, 2
    Offset = Offset + Setoff + &H10
   
    nmeSetOff = (rombank - 1) * 16384 - 10080
    nmeOffset = 0
    DQBpeek VARSEG(nmeOffset), VARPTR(nmeOffset), nmePointOff, 2
    nmeOffset = nmeOffset + nmeSetOff + &H10
   
    IF StrongEnemy = -1 THEN
      DQBpeek VARSEG(getbyte), VARPTR(getbyte), nmeOffset, 1
      nmeOffset = nmeOffset + ASC(getbyte)
    END IF

    nmeConvert
    GetNewMap
   ELSE
   TheMap = TheOldMap
   END IF
  END IF
  TheOldMap = TheMap
 
  IF xd < oxd THEN
    ScrollMapLeft oxd, xd, 5
  END IF
  IF xd > oxd THEN
    ScrollMapRight oxd, xd, 5
  END IF


  DrawMap xd, 0, 15, 0
  oxd = xd      'Set original position for scrolling

  DispKeys "choose"     'Display Keys
  DispStats "choose"  'Display Stats

  a$ = ""       'Don't use prevoius INKEY$

  DO                    'Wait for a key to be pressed
   a$ = INKEY$          'Store the ascii in a$
  LOOP WHILE a$ = ""    'end the wait loop
 
  SELECT CASE UCASE$(a$)
    CASE "4", "2", "8", "6"
      SELECT CASE a$
        CASE "4": change = 0
        CASE "2": change = 1
        CASE "8": change = 2
        CASE "6": change = 3
      END SELECT
      NewMap = 0
      NewMapOff = rombank * 16384 + &H72B
      IF DaSet AND 1 THEN NewMapOff = NewMapOff + &H1ADD
     
      DQBpeek VARSEG(NewMap), VARPTR(NewMap), NewMapOff + DaMap * 4 + change, 1
      EntryStyle = NewMap AND 3
      NewMap = NewMap \ 4
      IF NewMap < 63 THEN
        TheMap = DaSet * 63 + NewMap
        IF DaSet > 5 THEN TheMap = TheMap - 63
      ELSE
        SOUND 878, 1
      END IF

    CASE "O"
      DoLinkSys "OVER"
      DQBclose
      SHELL "OverEdit.EXE " + filename
     
      Initalize
      setpal ((byte4 \ 8) MOD 8)
      DoLinkSys ""

   
    CASE "P": Prefs
    CASE "H": HexDump Offset
    CASE CHR$(0) + "K": xd = xd - 4
    CASE CHR$(0) + "M": xd = xd + 4
   
    CASE ",", "<": xd = xd - 1
    CASE ".", ">": xd = xd + 1
    CASE CHR$(0) + "I": TheMap = TheMap - 1
    CASE CHR$(0) + "Q": TheMap = TheMap + 1
    CASE "E": Editor
    CASE "M": nmeEditor
    CASE "W"
      StrongEnemy = NOT StrongEnemy
      nmeOffset = 0
      DQBpeek VARSEG(nmeOffset), VARPTR(nmeOffset), nmePointOff, 2
      nmeOffset = nmeOffset + nmeSetOff + &H10
  
      IF StrongEnemy = -1 THEN
        DQBpeek VARSEG(getbyte), VARPTR(getbyte), nmeOffset, 1
        nmeOffset = nmeOffset + ASC(getbyte)
      END IF

      nmeConvert
      GetNewMap
     
    CASE "J"
      DQBboxf 0, 256, 0, 319, 199, 0
      ShadowPrint "Enter the map", 256, 0
      ShadowPrint "to jump to:", 256, 8
      LOCATE 4, 33
      COLOR 7
      INPUT TheMap
   
    CASE "N"
      SaveIt
      DQBclose
      SCREEN 0, 0, 1, 1
      SCREEN 0, 1, 0, 0
      WIDTH 80, 25
      SHELL "NESTicle.EXE " + filename
      Initalize
      setpal ((byte4 \ 8) MOD 8)
    CASE CHR$(27): EXIT SUB

  END SELECT

  IF xd < 0 THEN xd = 0     'Forbid scolling beyond left edge
  IF xd > 48 THEN xd = 48   '...and right edge!
 
LOOP

END SUB

SUB DoLinkSys (pass AS STRING)

LinkSys = ""

IF pass = "" THEN 'Read mode
  OPEN "Delete.Me" FOR BINARY AS #1
  IF LOF(1) = 0 THEN
    CLOSE
    KILL "Delete.Me"
  ELSE
    CLOSE
    OPEN "Delete.Me" FOR INPUT AS #1
    INPUT #1, LinkSys
    CLOSE
    KILL "Delete.Me"
  END IF
ELSE           'Write mode
  OPEN "Delete.Me" FOR OUTPUT AS #1
    PRINT #1, pass
  CLOSE
END IF

END SUB

SUB EditBack

DIM bkPointOff AS LONG

IF BackEdit THEN EXIT SUB

DrawDialogBox

IF LvMov THEN

  ShadowPrint "Warning!", 70, 20
  ShadowPrint "You must first save changes to the level!", 30, 30
  ShadowPrint "Press S to save changes now, or other key to abort.", 30, 38

  DO: k$ = UCASE$(INKEY$): LOOP WHILE k$ = ""

  IF k$ = "S" THEN
    IF IntegrityCheck(1) THEN
      PutMapBack
      SaveIt
      saved = -1
    END IF
  END IF

  IF saved <> -1 THEN EXIT SUB

  LvMod = 0

END IF

DIM bk, rst, setbyte AS STRING * 1, oldoffset AS LONG, Po AS LONG

DQBboxf 0, 256, 0, 319, 199, 0

DispKeys "back"

oldbyte4 = byte4
bk = byte4 MOD 8
rst = byte4 AND &HF8

oxd = xd

DO
 
  IF xd < oxd THEN
    ScrollMapLeft oxd, xd, 4
  END IF
  IF xd > oxd THEN
    ScrollMapRight oxd, xd, 4
  END IF
 
  DrawMap xd, 0, 15, 0
 
  oxd = xd
 
  DQBboxf 0, 256, 70, 319, 199, 0
  ShadowPrint "Backgrnd:" + HEX$(bk), 256, 96

  DO
    k$ = UCASE$(INKEY$)
  LOOP WHILE k$ = ""

  SELECT CASE k$
    CASE CHR$(0) + "K"
      bk = bk - 1
      IF bk < 0 THEN bk = 7

    CASE CHR$(0) + "M"
      bk = bk + 1
      IF bk > 7 THEN bk = 0

    CASE ",", "<"
      xd = xd - 1
      IF xd < 0 THEN xd = 0

    CASE ".", ">"
      xd = xd + 1
      IF xd > 48 THEN xd = 48

    CASE CHR$(27)
      byte4 = oldbyte4

      setbyte = CHR$(byte4)
      DQBpoke VARSEG(setbyte), VARPTR(setbyte), Offset + 3, 1

      GetNewMap
      DrawMap xd, 0, 15, 0
     
      EXIT SUB
    CASE CHR$(13)
      EXIT DO
    CASE "E"
      LvMod = -1
      BackEdit = TRUE
      oldoffset = Offset
      DaBk = bk
      bkPointOff = &HE + DaBk * 2 + 16384 * rombank

      Setoff = (rombank - 2) * 16384
      Offset = 0
     
      DQBpeek VARSEG(Offset), VARPTR(Offset), bkPointOff, 2
      Offset = Offset + Setoff + &H10

      GetNewMap
      DrawMap xd, 0, 15, 0

      Editor

      Offset = oldoffset

      GetNewMap
  END SELECT

  byte4 = bk + rst

  setbyte = CHR$(byte4)
  DQBpoke VARSEG(setbyte), VARPTR(setbyte), Offset + 3, 1

  GetNewMap

LOOP

  byte4 = bk + rst

  setbyte = CHR$(byte4)
  DQBpoke VARSEG(setbyte), VARPTR(setbyte), Offset + 3, 1

  GetNewMap
  DrawMap xd, 0, 15, 0
 
  LvMod = -1

END SUB

SUB Editor

DO
  ScrollHandler 'Smooth Scrolling!
  DrawMap xd, 0, 15, 0 'Draw the map's final position
  oxd = xd      'Set original position for scrolling
 
  DispKeys "main"   'Display Keys
  DispStats "main"  'Display Stats
 
  DrawBox xd, ooff  'Draw the yellow cursor
 
  a$ = ""       'Don't use prevoius INKEY$
 
  DO                    'Wait for a key to be pressed
   a$ = INKEY$          'Store the ascii in a$
  LOOP WHILE a$ = ""    'end the wait loop

  SELECT CASE UCASE$(a$)  'Check which key pressed
  
    CASE "B": EditBack
   
    CASE "H": HexDump Offset

    CASE "I"
      Z = IntegrityCheck(0)
   
    CASE "S"
      IF IntegrityCheck(1) THEN
        LvMod = 0
        PutMapBack
        SaveIt
      END IF

    CASE "T"              'Pressed T?
      TsetEdit              'Enter the Tileset Editor

    CASE "P"              'Pressed P?
      PalEdit               'Enter the palette editor
   
    CASE "F"              'Pressed F?
      FlagsEdit             'Enter the Flags editor
   
    CASE "2"                              'Pressed down on numeric keypad?
      LvMod = -1
      obj(ooff).yp = obj(ooff).yp + 1                'Increase the Y position
      IF obj(ooff).yp >= 16 THEN obj(ooff).yp = 15   '...and make it <= 15
      RenderMap                                      'Remake the tilemap

    CASE "4"      'Pressed left on numeric keypad?
      LvMod = -1
      MoveItLeft    'Move the object left
      xd = GetX(ooff) - 8
      IF xd < 0 THEN xd = 0
      IF xd > 48 THEN xd = 48
      oxd = xd
      RenderMap     'and remake the tilemap

    CASE "6"      'Pressed Right on numeric keypad?
      LvMod = -1
      MoveItRight   'Move the object right
      xd = GetX(ooff) - 8
      IF GetX(ooff) < 9 THEN xd = 0
      IF xd > 48 THEN xd = 48
      oxd = xd
      RenderMap     'and remake the tilemap

    CASE "["
      LvMod = -1
      IF ooff < numobj AND obj(ooff + 1).xs > 0 THEN
        obj(ooff + 1).xs = obj(ooff + 1).xs - 1
        RenderMap
      END IF
   
    CASE "]"
      LvMod = -1
      IF ooff < numobj THEN
        obj(ooff + 1).xs = obj(ooff + 1).xs + 1
        RenderMap
      END IF
   
    CASE "8"                              'Pressed Up on numeric keypad?
      LvMod = -1
      obj(ooff).yp = obj(ooff).yp - 1           'Decrease Y position
      IF obj(ooff).yp < 0 THEN obj(ooff).yp = 0 'no less than 0
      RenderMap                                 'remake tilemap
   
    CASE "*"                              'Pressed '*'?
      ChangeObj 16
    CASE "/"                              'Pressed '/'?
      ChangeObj -16
    CASE "+", "="                         'Pressed Plus?
      ChangeObj 1
    CASE "-", "_"                         'Pressed Minus?
      ChangeObj -1
   
    CASE ",", "<": xd = xd - 1   '<  and  > scroll left and right
    CASE ".", ">": xd = xd + 1

'    CASE "Z"                          'Z and X change map offsets bigly
'      offset = offset - 16
'      GetNewMap
      'convert
      'RenderMap
'    CASE "X"
'      offset = offset + 16
'      GetNewMap
      'convert
      'RenderMap
'    CASE CHR$(34)                     ': and " change map offsets
'      offset = offset + 1
'      GetNewMap
      'convert
      'RenderMap
'    CASE ":"
'      offset = offset - 1
'      GetNewMap
      'convert
      'RenderMap
  
    CASE CHR$(0) + "K"           'Hit left?
      IF xd = 48 AND xd > GetX(ooff) - 8 THEN
        xd = GetX(ooff) - 8
      ELSE
        IF ooff = 0 THEN             'At leftmost object?
          xd = 0                       'Move the scroller to the left end
        ELSE                         'Normally:
          ooff = ooff - 1              'Decrease selected object
          xd = GetX(ooff) - 8          'Change scrolling location
        END IF
      END IF
    CASE CHR$(0) + "M"           'Hit Right?
      IF xd = 0 AND xd < GetX(ooff) - 14 THEN
        xd = GetX(ooff) - 8
      ELSE
        IF ooff = numobj THEN        'at end of objects?
          xd = 48                      'scroll to right edge
        ELSE                         'Normally:
          ooff = ooff + 1              'Increase selected object
          xd = GetX(ooff) - 8          'change scrolling location
        END IF
      END IF
    CASE CHR$(27)
      IF BackEdit THEN
        IF CheckChangedMap = 0 THEN EXIT DO
      ELSE
        EXIT DO
      END IF

  END SELECT

IF xd < 0 THEN xd = 0     'Forbid scolling beyond left edge
IF xd > 48 THEN xd = 48   '...and right edge!

LOOP                      'Quit on ESC

END SUB

FUNCTION GetKey$
k$ = "": DO: k$ = INKEY$: LOOP WHILE k$ = "": GetKey$ = UCASE$(k$)
END FUNCTION

SUB GetNewMap

DIM getbyte AS STRING * 1

DQBpeek VARSEG(getbyte), VARPTR(getbyte), Offset, 1
byte1 = ASC(getbyte)
DQBpeek VARSEG(getbyte), VARPTR(getbyte), Offset + 1, 1
byte2 = ASC(getbyte)
DQBpeek VARSEG(getbyte), VARPTR(getbyte), Offset + 2, 1
byte3 = ASC(getbyte)
DQBpeek VARSEG(getbyte), VARPTR(getbyte), Offset + 3, 1
byte4 = ASC(getbyte)

makeback

Convert

RenderMap

setpal ((byte4 \ 8) MOD 8)

END SUB

FUNCTION GetX (objno AS INTEGER)
ex = 0
FOR tx = 0 TO objno
  'ex = (ex \ 16 + 1) * 16
  IF obj(tx - 1).yp = &HE THEN ex = (obj(tx - 1).xs) * 16
  ex = ex + obj(tx).xs
NEXT
GetX = ex
END FUNCTION

SUB HexDump (where AS LONG)
DIM x, Dat AS STRING
DIM getbyte AS STRING * 1

IF verbose = 0 THEN EXIT SUB

DQBclearLayer 0

ShadowPrint HEX$(where) + "-", 0, 0

OPEN "Z2HexDmp.txt" FOR APPEND AS #2
PRINT #2, HEX$(where) + "-";

FOR x = 0 TO 15
  DQBpeek VARSEG(getbyte), VARPTR(getbyte), where + x, 1
  Dat = HEX$(ASC(getbyte))
  IF LEN(Dat) = 1 THEN Dat = "0" + Dat
  PRINT #2, " " + Dat;
  ShadowPrint Dat, 23 + x * 10, 0
NEXT

PRINT #2, ""
CLOSE #2

Paws

END SUB

SUB Initalize

'Intialize DirectQB

Z = DQBinit(5, 0, 129)
IF Z THEN
  PRINT "Error initalizing DirectQB:"
  PRINT DQBerror$
  END
END IF

'Load the bitmap of enemies

Z = DQBloadImage(3, 0, 0, "z2Nme.bmp", Pal, 320, 200)
IF Z THEN
  PRINT "Error loading image 'z2Nme.bmp':"
  PRINT DQBerror$
  DQBclose
  END
END IF

'Load the bitmap of tiles

Z = DQBloadImage(4, 0, 0, "z2pltile.bmp", Pal, 320, 200)
IF Z THEN
  PRINT "Error loading image 'z2pltile.bmp':"
  PRINT DQBerror$
  DQBclose
  END
END IF

'Load the font (tiny.fnt)

Z = DQBloadFont("tiny.fnt")
IF Z THEN
  PRINT "Error loading font 'tiny.fnt':"
  PRINT DQBerror$
  DQBclose
  END
END IF

'Verify the existance of the palette file

DIM palname AS STRING
palname = "Bmfpal22.pal"

OPEN palname FOR BINARY AS #1
  IF LOF(1) = 0 THEN
    PRINT "BMFPAL22.PAL not found!"
    DQBclose
    SYSTEM
  END IF
 
  palstring = SPACE$(LOF(1))
  GET #1, 1, palstring
CLOSE

'Set VGA mode 13
SCREEN 13

'Set the palette
DQBsetPal Pal

'And finally load the file:

DIM buff AS STRING * 512

DIM tempoff AS LONG
tempoff = 16
OPEN filename FOR BINARY AS #1
  DO
    GET #1, tempoff + 1, buff
    DQBpoke VARSEG(buff), VARPTR(buff), tempoff, 512
    tempoff = tempoff + 512
    IF tempoff >= 131071 THEN EXIT DO
  LOOP
CLOSE

END SUB

FUNCTION IntegrityCheck (F AS INTEGER)

IntegrityCheck = -1   'True until proven false

Z = Checkit           'Do the actual check

IF Z > -1 THEN                        'Error?
  IntegrityCheck = 0                     'No save for you.
  ooff = Z MOD 256                       'Jump the the troubling object
  xd = GetX(ooff) - 8                    'and scroll to it as well
  DrawDialogBox
  DQBxPut 4, 0, 192, 85, 199, 0, 80, 20  'I AM ERROR!
  SELECT CASE Z                          'Which error?
    CASE 0 TO 255  'Error 1, illegal xspace
      ShadowPrint "THERE IS MORE THAN 15 SPACES BETWEEN OBJECTS!  MOVE THE", 30, 30
      ShadowPrint "OBJECTS CLOSER TOGETHER, OR ADD A SKIP TO CORRECT THIS.", 30, 37
      ShadowPrint "(this error can also be caused by a glitch", 30, 46
      ShadowPrint "   that results in  -1  space!)", 30, 53
      Paws    'Pause :)
      
    CASE 256 TO 511 'Error 2, Crash object
      ShadowPrint "THERE'S A Crash OBJECT (evil windows logo) IN THIS LEVEL!", 30, 35
      ShadowPrint "Change it, or the game will crash when loading this level.", 30, 45
      Paws    'Pause :)
    CASE 512 TO 767 'Error 3, Off the edge
      ShadowPrint "Some of the objects in this level are off the right edge", 30, 30
      ShadowPrint "of the map!", 30, 36
      IF F THEN
        ShadowPrint "(Press S right now to save the level anyway!)", 30, 50
        IF GetKey$ = "S" THEN
          IntegrityCheck = TRUE
        END IF
      ELSE
        Paws
      END IF
    CASE 768 TO 1023 'Error 4, illegal ycoord
      ShadowPrint "THE Y COORDINATE OF THIS OBJECT WENT BAD!", 30, 30
      ShadowPrint "Try moving it up and down, until it's on the page.", 30, 37
      Paws    'Pause :)
    CASE 1024 TO 1280
      ShadowPrint "THE OBJECT VALUE OF THIS OBJECT WENT BAD!", 30, 30
      ShadowPrint "Try changing the object type, until it's between 0 and 511.", 30, 37
      Paws    'Pause :)
    CASE ELSE
      ShadowPrint "Nice to meet you, Error.  Now tell me about the palace.", 30, 30
      Paws    'Pause (:
  END SELECT
END IF

END FUNCTION

SUB LoadFile
DIM loaf AS LONG

temp = CSRLIN

back:

IF cmd$ = "" THEN
  filename = Prompt$("File Name:", "NES", "Zelda2Ed.NES")
ELSE
  filename = UCASE$(cmd$)
  IF RIGHT$(filename, 4) <> ".NES" THEN filename = filename + ".NES"
END IF

cmd$ = ""

ffile = FREEFILE
OPEN filename FOR BINARY AS #ffile
  loaf = LOF(ffile)
  CLOSE
  IF loaf = 0 THEN
    CLOSE
    PRINT : PRINT : PRINT
    PRINT "The file, "; filename; " was not found.  Do you want to create it?"
    SELECT CASE YesOrNo
      CASE 1: KILL filename
      newfilename$ = filename
      DO
        filename = Prompt$("Enter EXISTING Z2 file:", "NES", "Zelda2.NES")
        OPEN filename FOR BINARY AS #ffile
        loaf = LOF(ffile): CLOSE
        IF loaf = 0 THEN
          KILL filename
          PRINT : PRINT : PRINT : PRINT "That file doesn't exist."
        ELSE
          SHELL "COPY " + filename + " " + newfilename$ + " /V /B"
          filename = newfilename$
          twemp = 1
        END IF
      LOOP UNTIL twemp = 1
      CASE 0: KILL filename
      GOTO back
    END SELECT
  ELSE
    CLOSE
  END IF
END SUB

SUB MoveItLeft

IF GetX(ooff) = 0 THEN EXIT SUB

IF ooff < numobj THEN
  obj(ooff + 1).xs = obj(ooff + 1).xs + 1
END IF

obj(ooff).xs = obj(ooff).xs - 1

IF obj(ooff).xs < 0 THEN
  obj(ooff).xs = 0
  obj(ooff + 1).xs = obj(ooff + 1).xs - 1
  DO
    SWAP obj(ooff).yp, obj(ooff - 1).yp
    SWAP obj(ooff).ob, obj(ooff - 1).ob
    ooff = ooff - 1
    IF obj(ooff).xs > 0 THEN
      obj(ooff + 1).xs = obj(ooff + 1).xs + 1
      obj(ooff).xs = obj(ooff).xs - 1
      EXIT DO
    END IF
  LOOP
END IF

END SUB

SUB MoveItRight
obj(ooff).xs = obj(ooff).xs + 1         'Increments the XSPACE
                                        'of the selected object
IF ooff = numobj THEN EXIT SUB          'Last Object?  Do nothing.

obj(ooff + 1).xs = obj(ooff + 1).xs - 1 'Decrements the XSPACE
                                        '
IF obj(ooff + 1).xs < 0 THEN
  SWAP obj(ooff).yp, obj(ooff + 1).yp
  SWAP obj(ooff).ob, obj(ooff + 1).ob
  obj(ooff).xs = obj(ooff).xs - 1
  ooff = ooff + 1
  obj(ooff).xs = 0
  MoveItRight
END IF

END SUB

SUB nmeConvert

DIM oldoffset AS LONG

oldoffset = nmeOffset

DIM bite AS INTEGER
DIM getbyte AS STRING * 1
DIM x AS INTEGER
DIM y AS INTEGER
x1 = 0
ycoord = 0


DQBpeek VARSEG(getbyte), VARPTR(getbyte), nmeOffset, 1
nmelen = ASC(getbyte)

nmeOffset = nmeOffset + 1

FOR x = 0 TO 127: nme(x).xs = 0: nme(x).yp = 0: nme(x).ob = 0: NEXT

nmeno = 0

WHILE nmeOffset < oldoffset + nmelen
  DQBpeek VARSEG(getbyte), VARPTR(getbyte), nmeOffset, 1
  bite = ASC(getbyte)
  xspace = bite AND 15: ycoord = bite \ 16
  nme(nmeno).yp = ycoord

  DQBpeek VARSEG(getbyte), VARPTR(getbyte), nmeOffset + 1, 1
  object = ASC(getbyte)
  nme(nmeno).ob = object MOD 64
  nme(nmeno).xs = xspace + (object \ 64) * 16

  nmeno = nmeno + 1
  nmeOffset = nmeOffset + 2

WEND


numnme = nmeno - 1
nmeOffset = oldoffset

nmeSort

END SUB

SUB nmeEditor

noff = 0
xd = 0: oxd = 0
DO
  ScrollHandler 'Smooth Scrolling!
  DrawMap xd, 0, 15, 0 'Draw the map's final position
  oxd = xd      'Set original position for scrolling

  DispKeys "Nme"   'Display Keys
  DispStats "Nme"  'Display Stats

  nmeDrawBox xd, noff  'Draw the yellow cursor

  a$ = ""       'Don't use prevoius INKEY$

  DO                    'Wait for a key to be pressed
   a$ = INKEY$          'Store the ascii in a$
  LOOP WHILE a$ = ""    'end the wait loop

  SELECT CASE UCASE$(a$)  'Check which key pressed
 
    CASE "H": HexDump nmeOffset

    CASE "S"
      PutNmeBack
      SaveIt

    CASE "2"                              'Pressed down on numeric keypad?
      nme(noff).yp = nme(noff).yp + 1                'Increase the Y position
      IF nme(noff).yp > 15 THEN nme(noff).yp = 15    '...and make it <= 15
      nmeRecenter

    CASE "4"      'Pressed left on numeric keypad?
      nmeSetx noff, nme(noff).xs - 1
      nmeRecenter

    CASE "6"      'Pressed Right on numeric keypad?
      nmeSetx noff, nme(noff).xs + 1
      nmeRecenter

    CASE "8"                              'Pressed Up on numeric keypad?
      nme(noff).yp = nme(noff).yp - 1           'Decrease Y position
      IF nme(noff).yp < 0 THEN nme(noff).yp = 0 'no less than 0
      nmeRecenter

    CASE "*"                              'Pressed '*'?
      ChangeNme 4
    CASE "/"                              'Pressed '/'?
      ChangeNme -4
    CASE "+", "="                         'Pressed Plus?
      ChangeNme 1
    CASE "-", "_"                         'Pressed Minus?
      ChangeNme -1

    CASE ",", "<": xd = xd - 1   '<  and  > scroll left and right
    CASE ".", ">": xd = xd + 1

'    CASE "Z"                          'Z and X change map offsets bigly
'      Offset = Offset - 16
'      convert
'      renderNme
'    CASE "X"
'      Offset = Offset + 16
'      convert
'      renderNme
'    CASE CHR$(34)                     ': and " change map offsets
'      Offset = Offset + 1
'      convert
'      renderNme
'    CASE ":"
'      Offset = Offset - 1
'      convert
'      renderNme
 
    CASE CHR$(0) + "K"           'Hit left?
      IF xd = 48 AND xd > nme(noff).xs - 8 THEN
        xd = nme(noff).xs - 8
      ELSE
        IF noff = 0 THEN             'At leftmost object?
          xd = 0                       'Move the scroller to the left end
        ELSE                         'Normally:
          noff = noff - 1              'Decrease selected object
          xd = nme(noff).xs - 8       'Change scrolling location
        END IF
      END IF
  
    CASE CHR$(0) + "M"           'Hit Right?
      IF xd = 0 AND xd < nme(noff).xs - 14 THEN
        xd = nme(noff).xs - 8
      ELSE
        IF noff >= numnme THEN        'at end of objects?
          xd = 48                      'scroll to right edge
        ELSE                         'Normally:
          noff = noff + 1              'Increase selected object
          xd = nme(noff).xs - 8       'change scrolling location
        END IF
      END IF
  END SELECT

IF xd < 0 THEN xd = 0     'Forbid scolling beyond left edge
IF xd > 48 THEN xd = 48   'and right edge!

LOOP UNTIL a$ = CHR$(27)  'Quit on ESC


END SUB

SUB nmeRecenter
     
xd = nme(noff).xs - 8       'Change scrolling location
IF xd < 0 THEN xd = 0
IF xd > 48 THEN xd = 48
oxd = xd

END SUB

SUB nmeSetx (nmeno, x)

IF x < 0 THEN x = 63
IF x > 63 THEN x = 0

nme(nmeno).xs = x

nmeSort

END SUB

SUB nmeSort
DIM index, min, low, lowindex, high, x, enabledswap

DIM switch AS objtype, initnoff AS objtype

initnoff = nme(noff)

FOR min = 0 TO numnme
  low = 64
  FOR index = min TO numnme
    x = nme(index).xs
    IF x < low THEN
      low = x
      lowindex = index
    END IF
  NEXT
  switch = nme(min)
  nme(min) = nme(lowindex)
  nme(lowindex) = switch
NEXT

FOR x = 0 TO numnme
  IF (initnoff.xs = nme(x).xs) AND (initnoff.yp = nme(x).yp) AND (initnoff.ob = nme(x).ob) THEN
    noff = x
    EXIT FOR
  END IF
NEXT

END SUB

SUB Paws
DIM k$
k$ = "": DO: k$ = INKEY$: LOOP WHILE k$ = ""
END SUB

SUB Prefs

vb = verbose
nc = NoCandle
sm = ScrollMode


DO
  DQBboxf 0, 256, 0, 319, 199, 0
  ShadowPrint "Prefs:", 256, 0
  ShadowPrint "ESC:Cancel", 256, 8
  ShadowPrint "ENTER:OK", 256, 16
  ShadowPrint "Display Prefs:", 256, 32
 
  IF NoCandle THEN ShadowPrint "X", 256, 40
  ShadowPrint "No Candle", 264, 40
  ShadowPrint "C", 314, 40
 
  IF verbose THEN ShadowPrint "X", 256, 48
  ShadowPrint "Verbose", 264, 48
  ShadowPrint "V", 314, 48
 
  SELECT CASE ScrollMode
    CASE 0: ShadowPrint "Smooth & slow", 264, 62
    CASE 1: ShadowPrint "Fast & Jerky", 264, 62
    CASE 2: ShadowPrint "Disabled", 264, 62
  END SELECT
  ShadowPrint "Scroll Mode", 256, 56
  ShadowPrint "S", 314, 56
 
  DO: k$ = UCASE$(INKEY$): LOOP WHILE k$ = ""
  SELECT CASE k$
    CASE CHR$(27)
      verbose = vb
      NoCandle = nc
      ScrollMode = sm
      EXIT SUB
    CASE "V"
      verbose = NOT verbose
    CASE "C"
      NoCandle = NOT NoCandle
    CASE "S"
      ScrollMode = ScrollMode + 1
      IF ScrollMode = 3 THEN ScrollMode = 0
    CASE CHR$(13)
      EXIT DO
  END SELECT

LOOP

END SUB

FUNCTION Prompt$ (pmt AS STRING, ext AS STRING, dft AS STRING)

DIM a$

lin = CSRLIN
LOCATE lin, 1

PRINT SPACE$(LEN(pmt) + 16)

PRINT "     (" + CHR$(34) + dft + CHR$(34) + " if no file specified)";
lin = CSRLIN - 1

LOCATE lin, 1

PRINT pmt + "________."; ext;
LOCATE lin, LEN(pmt) + 1, 1, 14, 16

DIM pstring$

fini = 0
DO

DO: a$ = INKEY$: LOOP WHILE a$ = ""

SELECT CASE ASC(a$)
  CASE 27
    LOCATE , LEN(pmt) + 15, 0
    PRINT "Abort program?"
    IF YesOrNo = 1 THEN SYSTEM
    LOCATE lin, LEN(pmt + pstring$) + 1, 1
  CASE 7: BEEP
  CASE 8
    IF LEN(pstring$) > 0 THEN
      pstring$ = LEFT$(pstring$, LEN(pstring$) - 1)
      LOCATE CSRLIN, POS(0) - 1
      PRINT "_";
      LOCATE CSRLIN, POS(0) - 1
  END IF

  CASE 13
    fini = 1

  CASE IS < 33
  CASE ELSE
    IF LEN(pstring$) < 8 THEN
      PRINT a$;
      pstring$ = pstring$ + a$
  END IF

END SELECT

a$ = ""
LOOP UNTIL fini = 1
LOCATE , , 0

FOR twemp = 1 TO LEN(pstring$)
  IF MID$(pstring$, twemp, 1) = "." THEN
    pstring$ = LEFT$(pstring$, twemp - 1)
  END IF
NEXT



Prompt$ = UCASE$(pstring$ + "." + ext)
IF pstring$ = "" THEN Prompt$ = UCASE$(dft)


END FUNCTION

SUB PutNmeBack

DIM oldoffset AS LONG

oldoffset = nmeOffset

DIM setbyte AS STRING * 1

setbyte = CHR$(nmelen)
DQBpoke VARSEG(setbyte), VARPTR(setbyte), nmeOffset, 1

nmeOffset = nmeOffset + 1

DO
  setbyte = CHR$((nme(nmeno).xs AND 15) + nme(nmeno).yp * 16)
  DQBpoke VARSEG(setbyte), VARPTR(setbyte), nmeOffset, 1

  setbyte = CHR$(nme(nmeno).ob + (nme(nmeno).xs \ 16) * 64)
  DQBpoke VARSEG(setbyte), VARPTR(setbyte), nmeOffset + 1, 1

  nmeno = nmeno + 1
  nmeOffset = nmeOffset + 2

LOOP UNTIL nmeOffset >= oldoffset + nmelen
nmeOffset = oldoffset


END SUB

SUB QuitIt
DQBclose
DQBinitText
END SUB

SUB SaveIt

DIM buff AS STRING * 512

DIM tempoff AS LONG
tempoff = 16
OPEN filename FOR BINARY AS #1
  DO
    DQBpeek VARSEG(buff), VARPTR(buff), tempoff, 512
    PUT #1, tempoff + 1, buff
    tempoff = tempoff + 512
    IF tempoff >= 131071 THEN EXIT DO

  LOOP
CLOSE

END SUB

SUB setpal (pl AS INTEGER)
IF pl = 1 AND NoCandle = -1 THEN pl = 8
ep = byte4 \ 64 + 9
IF pl = 8 AND NoCandle = -1 THEN ep = 13
DIM Colors AS STRING * 32

DIM paloff AS LONG
paloff = 16384 * rombank + &H1E

DQBpeek VARSEG(Colors), VARPTR(Colors), paloff + pl * 16, 16

DQBpeek VARSEG(Colors), VARPTR(Colors) + 16, paloff + ep * 16, 16

FOR Col = 0 TO 31
  I = ASC(MID$(Colors, Col + 1, 1)) MOD 64
 
  R = ASC(MID$(palstring, I * 3 + 1, 1)) \ 4
  g = ASC(MID$(palstring, I * 3 + 2, 1)) \ 4
  B = ASC(MID$(palstring, I * 3 + 3, 1)) \ 4
  MID$(Pal, (Col + 16) * 3 + 1, 1) = CHR$(R)
  MID$(Pal, (Col + 16) * 3 + 2, 1) = CHR$(g)
  MID$(Pal, (Col + 16) * 3 + 3, 1) = CHR$(B)
NEXT

DQBsetPal Pal

END SUB

SUB Viewer

DO
  IF xd < oxd THEN              'Left of previous position?
    ScrollMapLeft oxd, xd, 4    'Scroll it left
  END IF
  IF xd > oxd THEN              'Right of previous position?
    ScrollMapRight oxd, xd, 4   'Scroll it Right
  END IF
 
  DrawMap xd, 0, 15, 0 'Draw the map's final position
  oxd = xd      'Set original position for scrolling

  DispKeys "view"   'Display Keys
  DispStats "nop"   'Hide Stats

  a$ = ""       'Don't use prevoius INKEY$

  DO                    'Wait for a key to be pressed
   a$ = INKEY$          'Store the ascii in a$
  LOOP WHILE a$ = ""    'end the wait loop

  SELECT CASE UCASE$(a$)  'Check which key pressed
    CASE CHR$(0) + "K": xd = xd - 1 '<- and -> scroll left and right
    CASE CHR$(0) + "M": xd = xd + 1
  END SELECT

  IF xd < 0 THEN xd = 0     'Forbid scolling beyond left edge
  IF xd > 48 THEN xd = 48   '...and right edge!

LOOP UNTIL a$ = CHR$(27)  'Quit on ESC


END SUB

FUNCTION YesOrNo
yn = -1
DO
a$ = INKEY$
SELECT CASE UCASE$(a$)
CASE "Y", "T", "U", "6": yn = 1
CASE "N", "M", "B", " ": yn = 0
END SELECT
LOOP WHILE yn = -1
YesOrNo = yn

END FUNCTION

